data S = Sa S S | Sb S S | Sc S S | E


-- b)

sePre :: S -> Int -> (Int, Bool)
sePre (Sa s1 s2) d0 =
  let (u1, b1) = sePre s1 d0
      d3 = u1 + 1
      (u3, b3) = sePre s2 d3
  in
  (u3, b1 && b3)

sePre (Sb s1 s2) d0 =
  let (u1, b1) = sePre s1 d0
      d3 = u1 - 1
      (u3, b3) = sePre s2 d3
  in
  (u3, b1 && d3 >= 0 && b3)

sePre (Sc s1 s2) d0 =
  let (u1, b1) = sePre s1 d0
      d3 = u1
      (u3, b3) = sePre s2 d3
  in
  (u3, b1 && b3)

sePre E d0 = (d0, True)


-- c)

seSuf :: S -> Int -> (Int, Bool)
seSuf (Sa s1 s2) d0 =
  let (u1, b1) = seSuf s1 d1
      d1 = u3 + 1
      (u3, b3) = seSuf s2 d0
  in
  (u1, b1 && b3)

seSuf (Sb s1 s2) d0 =
  let (u1, b1) = seSuf s1 d1
      d1 = u3 - 1
      (u3, b3) = seSuf s2 d0
  in
  (u1, b1 && d1 >= 0 && b3)

seSuf (Sc s1 s2) d0 =
  let (u1, b1) = seSuf s1 d1
      d1 = u3
      (u3, b3) = seSuf s2 d0
  in
  (u1, b1 && b3)

seSuf E d0 = (d0, True)

