-- a)

data B = O | I


data L = L1 B | L2 L B


data N = N1 L


be :: B -> (Int -> a) -> a
be O c = c 0
 
be I c = c 1


le :: L -> Int -> (Int -> a) -> a
le (L1 b) p0 c = be b (\v1 -> c (p0 * v1))

le (L2 l b) p0 c =
  le l (2 * p0) (\v1 -> be b (\v2 -> c (v1 + p0 * v2)))


ne :: N -> (Int -> a) -> a
ne (N1 l) c = le l 1 c


testBin = N1 (L2 (L2 (L2 (L1 I) I) O) I)


-- b)

quicksortCPS :: [Int] -> ([Int] -> [Int]) -> [Int]
quicksortCPS [] cont = cont []

quicksortCPS (x:xs) cont =
  let (le, gr) = span (<x) xs
  in
  quicksortCPS le (\l -> l ++ x : quicksortCPS gr cont) 


-- c)

unzipCPS :: [(a,b)] -> ([a] -> [b] -> c) -> c
unzipCPS [] cont = cont [] []

unzipCPS ((x1,x2):xs) cont =
  unzipCPS xs (\ys zs -> cont (x1:ys) (x2:zs))
